下载

要下载SPECFEM3D,可以在终端中输入以下命令:

$ git clone --recursive --branch devel https://github.com/geodynamics/specfem3d.git

注意:如果直接从 github 手动下载,然后再安装,有可能会出现一些问题,原因可能在于从 github 上直接下载的版本一般情况下并非 release 版本,因而针对不同的机器,可能会出现一些问题。若无法解决,建议采用上述语句重新下载 SPECFEM3D,然后再安装。

可选依赖包

以下安装包均为可选。

  • ifort编译器,可使用 gfortran 代替。
  • mpi并行环境,可安装不带 MPI 加速的版本
  • scotch,安装SPECFEM3D时会自动安装其目录下绑定的scotch版本,但版本不是最新版本

上述工具中建议安装 ifort 编译器,使用 gfortran 编译,可能会出现一些问题且编译效率低。

安装

进入specfem3d的根目录进行安装。

安装不带MPI的版本

$ ./configure FC=ifort --without-mpi
$ make

安装带MPI的版本

$ ./configure FC=ifort MPIFC=/opt/mpich3.3/bin/mpif90 MPI_INC=/opt/mpich3.3/include --with-mpi
$ make

注意:这里最好显式地给出mpif90的路径,不然编译的时候会调用系统里 安装的其他mpif90,然后就是给出MPI的include变量MPI_INC,编译 的时候会用到mpi.h头文件,所以需要从MPI_INC里找。

安装带 MPI 且使用非 SPECFEM3D 绑定的 scotch 版本

和安装带 MPI 的版本的差不多,只不过,采用的是下面的configure

$ ./configure FC=ifort MPIFC=/opt/mpich3.3/bin/mpif90 MPI_INC=/opt/mpich3.3/include --with-mpi -with-scotch-dir=/opt/scotch_6.0.4
$ make

注意:本文给出的/opt/mpich3.3,/opt/scotch_6.0.4只是个例子, 大家根据自己 mpich 和 scotch 的安装位置进行适当修改,没有必要一定 要将 mpich 和 scotch 安装在/opt下。

编译完成后,可以在 specfem3d 的根目录下发现有一个新的目录 bin/,该目录下包含 specfem3d 的二进制可执行文件。

修订历史

  • 2017-10-10:初稿;
  • 2018-08-01:更新无效的链接;
  • 2018-08-05:新增关于下载的注意事项;
  • 2018-11-25:更新mpich为3.3。